import os
import asyncio
from pyformance import global_registry
from pscr_common.metrics import get_reporter
from pscr_common.metadata import MetadataProvider
from threading import Thread


class Metrics:
    def __init__(self):
        self.metrics_registry = global_registry()
        self.reporter_thread = Thread(target=self.start_reporter, daemon=True)
        self.reporter_thread.start()

    def start_reporter(self):
        env = os.environ.get("ENV_ID", "unknown")
        env_meta = MetadataProvider().get_metadata()
        reporter = get_reporter(
            self.metrics_registry,
            env,
            env_meta.task_id,
            "org_mapper",
            env_meta.image.rsplit(":", maxsplit=1)[-1],
        )

        if reporter:
            asyncio.run(reporter._loop())
